/*
 * Determine which stream modules have been pushed onto a stream.
 */

#include	<stdio.h>
#include	<fcntl.h>
#include	<tiuser.h>
#include	<stropts.h>
#include	<sys/conf.h>

main()
{
	doit("/dev/tcp");
	doit("/dev/udp");
}

doit(name)
char	*name;
{
	int		tfd;
	char		filename[FMNAMESZ + 1];
	struct t_info	info;

	printf("stream = %s\n", name);
	if ( (tfd = t_open(name, O_RDWR, &info)) < 0)
	{
		fprintf(stderr, "Can't open %s", name);
		perror("");
		exit(1);
	}

	for ( ; ; ) {
		if (ioctl(tfd, I_LOOK, filename) < 0) {
			perror("ioctl I_LOOK error");
			break;
		}

		printf("	module = %s\n", filename);

		if (ioctl(tfd, I_POP, (char *) 0) < 0)
		{
			perror("ioctl I_POP error");
			exit(2);
		}
	}
	fflush(stdout);
}
