
/*  login.h:  Definitions to fine tune the login feature of tcpserv.

		-Sam Lantinga
*/

/* Define NEEDSHADOW if you are running a shadowed password file */
/*#define NEEDSHADOW		/**/
/* If you are running a shadowed password file, you will need to
   allow read access to the shadowed password file by this program. */

/* Define WELCOME as the message that is shown before the login
   message is shown.    */
#define WELCOME	"\r\n\tWelcome to Slouken's TCP Server.\r\n\r\n\r\n"


/* Define LOGIN as the login message first shown at a connection.  */
#define LOGIN	"Login: "

/* Define RETRIES as the number of incorrect login attempts that
   will be accepted before the connection is closed.     */
#define RETRIES	3

/* Define TIMEOUT as the number of seconds to wait at a login prompt
   before timing out and closing the connection.  Setting TIMEOUT to
   0 will disable the timeout feature.          */
#define TIMEOUT 60

/* Define MAILDIR as the directory in which all user mail is held. */
#define MAILDIR	"/usr/spool/mail"	/* The mail directory */
/*#define MAILDIR	"/var/spool/mail"	/* The mail directory */
/*#define MAILDIR	"/usr/mail"		/* The mail directory */
